<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::settings::SettingCallbacks&lt; ManagerT &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1settings.html">settings</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">SettingCallbacks</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::settings::SettingCallbacks&lt; ManagerT &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_setting_callbacks_8h_source.html">SettingCallbacks.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a5557f38900f9a313e6236fcee3c8d41b"><td class="memTemplParams" colspan="2">template&lt;size_t id&gt; </td></tr>
<tr class="memitem:a5557f38900f9a313e6236fcee3c8d41b"><td class="memTemplItemLeft" align="right" valign="top">using&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a5557f38900f9a313e6236fcee3c8d41b">ValueType</a> = typename ManagerT::template <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a5557f38900f9a313e6236fcee3c8d41b">ValueType</a>&lt; id &gt;</td></tr>
<tr class="memdesc:a5557f38900f9a313e6236fcee3c8d41b"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html">Setting</a> value type.  <a href="#a5557f38900f9a313e6236fcee3c8d41b">More...</a><br /></td></tr>
<tr class="separator:a5557f38900f9a313e6236fcee3c8d41b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f7550aa7dc547455f83ffd4bf58a536"><td class="memTemplParams" colspan="2">template&lt;size_t id&gt; </td></tr>
<tr class="memitem:a3f7550aa7dc547455f83ffd4bf58a536"><td class="memTemplItemLeft" align="right" valign="top">using&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a3f7550aa7dc547455f83ffd4bf58a536">FunctionType</a> = std::function&lt; void(const <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a5557f38900f9a313e6236fcee3c8d41b">ValueType</a>&lt; id &gt; &amp;, <a class="el" href="namespacealexa_client_s_d_k_1_1settings.html#a65b348e86299aa3f3fcdf4a5f924e025">SettingNotifications</a>)&gt;</td></tr>
<tr class="memdesc:a3f7550aa7dc547455f83ffd4bf58a536"><td class="mdescLeft">&#160;</td><td class="mdescRight">Callback function value type.  <a href="#a3f7550aa7dc547455f83ffd4bf58a536">More...</a><br /></td></tr>
<tr class="separator:a3f7550aa7dc547455f83ffd4bf58a536"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a04dad60ea8da41c18591a6ac5b7eadcf"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a04dad60ea8da41c18591a6ac5b7eadcf">~SettingCallbacks</a> ()</td></tr>
<tr class="separator:a04dad60ea8da41c18591a6ac5b7eadcf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a95e4964e5ffeb5543222f327df0f361c"><td class="memTemplParams" colspan="2">template&lt;size_t id&gt; </td></tr>
<tr class="memitem:a95e4964e5ffeb5543222f327df0f361c"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a95e4964e5ffeb5543222f327df0f361c">add</a> (<a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a3f7550aa7dc547455f83ffd4bf58a536">FunctionType</a>&lt; id &gt; callback)</td></tr>
<tr class="separator:a95e4964e5ffeb5543222f327df0f361c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae328284ba56fc87e6a346fb2fea0d754"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#ae328284ba56fc87e6a346fb2fea0d754">removeAll</a> ()</td></tr>
<tr class="separator:ae328284ba56fc87e6a346fb2fea0d754"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a802d4e9bc66d0938d8ecf5ae0a28ee25"><td class="memItemLeft" align="right" valign="top">static std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">SettingCallbacks</a>&lt; ManagerT &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a802d4e9bc66d0938d8ecf5ae0a28ee25">create</a> (std::shared_ptr&lt; ManagerT &gt; manager)</td></tr>
<tr class="separator:a802d4e9bc66d0938d8ecf5ae0a28ee25"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename ManagerT&gt;<br />
class alexaClientSDK::settings::SettingCallbacks&lt; ManagerT &gt;</h3>

<p class="">The <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">SettingCallbacks</a> allow easy management of callbacks to monitor multiple settings with one object only.</p>
<p class="">This object can be used to register multiple callbacks that are member functions, lambdas and static functions. E.g.:</p>
<div class="fragment"><div class="line">MyClass(std::shared_ptr&lt;DeviceSettingManagers&gt; manager) : m_callbacks {manager} {</div><div class="line">    m_callbacks.add&lt;ASCENDING_ALARM&gt;([](<span class="keywordtype">bool</span> enable, <a class="code" href="namespacealexa_client_s_d_k_1_1settings.html#a65b348e86299aa3f3fcdf4a5f924e025">SettingNotifications</a> notification){</div><div class="line">        <span class="comment">// do something...</span></div><div class="line">    });</div><div class="line">    m_callbacks.add&lt;TIMEZONE&gt;(staticFunction);</div><div class="line">    m_callbacks.add&lt;WAKEWORD_CONFIRMATION&gt;(std::bind(<span class="keyword">this</span>, &amp;MyClass::onWakewordConfirmation, std::placeholder::_1));</div><div class="line">}</div><div class="line"></div><div class="line">~MyClass() {</div><div class="line">    <span class="comment">// Observers get removed during destruction.</span></div><div class="line">}</div></div><!-- fragment --><p class="">If you would like to listen notifications related to only one setting, see <code>SettingEventCallback</code> class or extend the <code><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_observer_interface.html">SettingObserverInterface</a></code> class.</p>
<dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">SettingsT</td><td>Settings type enumeration. </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Member Typedef Documentation</h2>
<a id="a3f7550aa7dc547455f83ffd4bf58a536"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3f7550aa7dc547455f83ffd4bf58a536">&#9670;&nbsp;</a></span>FunctionType</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ManagerT &gt; </div>
<div class="memtemplate">
template&lt;size_t id&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">alexaClientSDK::settings::SettingCallbacks</a>&lt; ManagerT &gt;::<a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a3f7550aa7dc547455f83ffd4bf58a536">FunctionType</a> =  std::function&lt;void(const <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a5557f38900f9a313e6236fcee3c8d41b">ValueType</a>&lt;id&gt;&amp;, <a class="el" href="namespacealexa_client_s_d_k_1_1settings.html#a65b348e86299aa3f3fcdf4a5f924e025">SettingNotifications</a>)&gt;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Callback function value type. </p>

</div>
</div>
<a id="a5557f38900f9a313e6236fcee3c8d41b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5557f38900f9a313e6236fcee3c8d41b">&#9670;&nbsp;</a></span>ValueType</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ManagerT &gt; </div>
<div class="memtemplate">
template&lt;size_t id&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">using <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">alexaClientSDK::settings::SettingCallbacks</a>&lt; ManagerT &gt;::<a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a5557f38900f9a313e6236fcee3c8d41b">ValueType</a> =  typename ManagerT::template <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a5557f38900f9a313e6236fcee3c8d41b">ValueType</a>&lt;id&gt;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting.html">Setting</a> value type. </p>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a04dad60ea8da41c18591a6ac5b7eadcf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a04dad60ea8da41c18591a6ac5b7eadcf">&#9670;&nbsp;</a></span>~SettingCallbacks()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ManagerT &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">alexaClientSDK::settings::SettingCallbacks</a>&lt; ManagerT &gt;::~<a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">SettingCallbacks</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">The destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a95e4964e5ffeb5543222f327df0f361c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a95e4964e5ffeb5543222f327df0f361c">&#9670;&nbsp;</a></span>add()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ManagerT &gt; </div>
<div class="memtemplate">
template&lt;size_t id&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">alexaClientSDK::settings::SettingCallbacks</a>&lt; ManagerT &gt;::add </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">SettingCallbacks</a>&lt; ManagerT &gt;::<a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html#a3f7550aa7dc547455f83ffd4bf58a536">FunctionType</a>&lt; id &gt;&#160;</td>
          <td class="paramname"><em>callback</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Add a callback function to the setting with <code>id</code>. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">id</td><td>The property id. </td></tr>
  </table>
  </dd>
</dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">callback</td><td>The callback function. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> if it succeeds; <code>false</code> otherwise. </dd></dl>

</div>
</div>
<a id="a802d4e9bc66d0938d8ecf5ae0a28ee25"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a802d4e9bc66d0938d8ecf5ae0a28ee25">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ManagerT &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">SettingCallbacks</a>&lt; ManagerT &gt; &gt; <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">alexaClientSDK::settings::SettingCallbacks</a>&lt; ManagerT &gt;::create </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; ManagerT &gt;&#160;</td>
          <td class="paramname"><em>manager</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Create a <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">SettingCallbacks</a> object.</p>
<p class="">This method allow user to use static / lambda functions as the callbacks.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">manager</td><td>The object that manages all settings. </td></tr>
    <tr><td class="paramname">callback</td><td>The callback function for <code>SettingT</code>. </td></tr>
    <tr><td class="paramname">otherCallbacks</td><td>The callback functions for the rest of the settings. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to new object if it succeeds to add all callbacks, <code>nullptr</code> otherwise. </dd></dl>

</div>
</div>
<a id="ae328284ba56fc87e6a346fb2fea0d754"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae328284ba56fc87e6a346fb2fea0d754">&#9670;&nbsp;</a></span>removeAll()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ManagerT &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classalexa_client_s_d_k_1_1settings_1_1_setting_callbacks.html">alexaClientSDK::settings::SettingCallbacks</a>&lt; ManagerT &gt;::removeAll </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Disconnects the observed setting from all observed settings. This function also gets called by the destructor.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">manager</td><td>The object that manages all settings. </td></tr>
    <tr><td class="paramname">observer</td><td>The observer object to be disconnected. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>if it succeeds, <code>false</code> otherwise. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/Settings/include/Settings/<a class="el" href="_setting_callbacks_8h_source.html">SettingCallbacks.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
